#property copyright "Shinigami 2007"
#property link      "shini1984@gmail.com"
/* Version History:
1.0 - first working version.
*/

#define ORDER_ID 2016
extern double BuyPrice = 0;
extern int BuyShift = 3;
extern double SellPrice = 0;
extern int SellShift = 3;
extern int SL = 1000;
extern int TP = 1000;
extern int TS = 0; //0 means don't use
extern string Typeee = "Price Type - 0 for spot order, 1 for stop order";
extern int Type = 0;
//---- input parameters for MM
extern string MM.start = "----------MoneyManagement---------";
extern string MM = "0 for basic lot, 1 for % of deposit"; // more to come
extern int MMformula = 1;
extern double BasicLot=0.1;
extern double MMRiskFactor=0.1;
extern int LotPrecision = 2;
extern int Magic = 2272; //magic number
string Comments = "Trading.Tool.by.Shinigami";
int OpenedBuy=0,OpenedSell=0;

/*
EA logics:
Open a Buy or Sell on the defined level.
Can open buy-stop and sell-stop as an alternative.
Uses money management.
Has a trailing stop.
Thats it!
*/

 
//----------------------------------------------------

int start()    //function of all functions
{
 RefreshRates();
 CheckOpened(); //checks if there is an order
 if(OpenedBuy!=0||OpenedSell!=0) //trail if there is an order
  {
   TrailingStop();
  }
 if(Ask>=BuyPrice)
  {
   if(Ask<=BuyPrice+BuyShift*Point)
    {
     OpenBuy(Type); //open BUY order
    }
  }
 if(Bid>=BuyPrice)
  {
   if(Bid<=BuyPrice+BuyShift*Point)
    {
     OpenSell(Type); //open BUY order
    }
  }

return(0);
}

//----------------------------------------------------

int CheckOpened() //check for open orders of exact type
{
 OpenedBuy=0; OpenedSell=0;
 int i=0;
 for(i=0;i<OrdersTotal();i++)
  {
   OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
   if(OrderMagicNumber()==Magic)
    {
     if(OrderSymbol()==Symbol())
      {
       if(OrderType()==OP_BUY)
        {
         if(TimeDayOfYear(OrderOpenTime())==TimeDayOfYear(TimeCurrent()))
         OpenedBuy=1;
        }
       if(OrderType()==OP_SELL)
        {
         if(TimeDayOfYear(OrderOpenTime())==TimeDayOfYear(TimeCurrent()))
         OpenedSell=1;
        }
      }
    }
  }
return(0);
}

//----------------------------------------------------

double CalculateMM()  //MoneyManagement calculation function, addressed only for lot calculation
{
 double lot,calculatedlot=0;
 if(MMformula==0)
  {
   lot=BasicLot;
   return(lot);
  }
 if(MMformula==1)
  {
   double lot_min =MarketInfo(Symbol(),MODE_MINLOT);
   double lot_max =MarketInfo(Symbol(),MODE_MAXLOT);
   double lot_step=MarketInfo(Symbol(),MODE_LOTSTEP);
    if(lot_min<0 || lot_max<=0.0 || lot_step<=0.0) 
     {
      Print("CalculateMMLot: invalid MarketInfo() results [",lot_min,",",lot_max,",",lot_step,"]");
      return(0);
     }
    if(AccountLeverage()<=0)
     {
      Print("CalculateMMLot: invalid AccountLeverage() [",AccountLeverage(),"]");
      return(0);
     }
    lot=NormalizeDouble(AccountBalance()*MMRiskFactor/AccountLeverage()/10.0,LotPrecision);
    lot=NormalizeDouble(lot/lot_step,0)*lot_step;
    if(lot<lot_min)
    lot=lot_min;
    if(lot>lot_max) 
    lot=lot_max;
    return(lot);
  }
}

//-----------------------------------------------------------
/*
int PendingOpen.MS() //open PENDING orders
{
// Print("MaxPrice ",MaxPrice,"    MinPrice ",MinPrice,"     Bid ",Bid);
   if(CheckBuys.MS()==0)
   OrderSend(Symbol(),OP_BUYSTOP,CalculateMM(),(MaxPrice.MS+BuyS.MS*Point),3,(MaxPrice.MS+BuyS.MS*Point)-SL.MS*Point,(MaxPrice.MS+BuyS.MS*Point)+TP.MS*Point,Comments.MS,Magic.MS,0,Green);
   if(CheckSells.MS()==0)
   OrderSend(Symbol(),OP_SELLSTOP,CalculateMM(),(MinPrice.MS-SellS.MS*Point),3,(MinPrice.MS-SellS.MS*Point)+SL.MS*Point,(MinPrice.MS-SellS.MS*Point)-TP.MS*Point,Comments.MS,Magic.MS,0,Green);
return(0);
}
*/
//----------------------------------------------------------

int OpenBuy(int type)
{
 RefreshRates();
if(CheckBuys()==0)
 {
  if(type==0)
  OrderSend(Symbol(),OP_BUY,CalculateMM(),Ask,3,Ask-SL*Point,Ask+TP*Point,Comments,Magic,0,Green);
  else if(type==1)
  OrderSend(Symbol(),OP_BUYSTOP,CalculateMM(),BuyPrice,3,BuyPrice-SL*Point,BuyPrice+TP*Point,Comments,Magic,0,Green);
 }
return(0);
}

//----------------------------------------------------------

int OpenSell(int type)
{
 RefreshRates();
if(CheckSells()==0)
 {
  if(type==0)
  OrderSend(Symbol(),OP_SELL,CalculateMM(),Bid,3,Bid+SL*Point,Bid-TP*Point,Comments,Magic,0,Green);
  else if(type==1)
  OrderSend(Symbol(),OP_SELLSTOP,CalculateMM(),SellPrice,3,SellPrice+SL*Point,SellPrice-TP*Point,Comments,Magic,0,Green);
 }
return(0);
}

//--------------------------------------------------------

int CheckBuys() //check for open orders of exact type
{
 int i=0;
 int buy=0;
 for(i=0;i<OrdersTotal();i++)
  {
   OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
   if(OrderMagicNumber()==Magic)
    {
     if(OrderSymbol()==Symbol())
      {
       if(OrderType()==OP_BUYLIMIT||OrderType()==OP_BUYSTOP)
       buy++;
       if(OrderType()==OP_BUY)
        {
         if(TimeDayOfYear(OrderOpenTime())==TimeDayOfYear(TimeCurrent()))
         buy++;
        }
      }
    }
  }
return(buy);
}

//------------------------------------------------------
int CheckSells() //check for open orders of exact type
{
 int i=0;
 int sell=0;
 RefreshRates();
 for(i=0;i<OrdersTotal();i++)
  {
   OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
   if(OrderMagicNumber()==Magic)
    {
     if(OrderSymbol()==Symbol())
      {
       if(OrderType()==OP_SELLLIMIT||OrderType()==OP_SELLSTOP)
       sell++;
       if(OrderType()==OP_SELL)
        {
         if(TimeDayOfYear(OrderOpenTime())==TimeDayOfYear(TimeCurrent()))
         sell++;
        }
      }
    }
  }
return(sell);
}

//------------------------------------------------------

int TrailingStop() // move stoploss according to trailing stop
{
RefreshRates();
int i;
for(i=0;i<OrdersTotal();i++)
 {//0
  OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
  if(OrderMagicNumber()==Magic)
   {//1
  if(OrderSymbol()==Symbol())
   {//2
    if(TS>0)
     {//3
      if(OrderType()==OP_BUY)
       {//4
        //if(OrderStopLoss()>OrderOpenPrice())
         {//5
          if(Bid-TS*Point>OrderStopLoss())
           {//6
            OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TS,OrderTakeProfit(),0,Moccasin);
           }//-6
         }//-5
       }//-4
      if(OrderType()==OP_SELL)
       {//44
        //if(OrderStopLoss()<OrderOpenPrice())
         {//55
          if(Ask+TS*Point<OrderStopLoss())
           {//66
            OrderModify(OrderTicket(),OrderOpenPrice(),Ask+TS*Point,OrderTakeProfit(),0,Pink);
           }//-66
         }//-55
       }//-44
     }//-33
   }//-2
 }//-1
 }//-0
return(0);
}

//--------------------------------------------------------------

